<?php
/*
  $
*/

class worldnet_sc
{
  var $code, $title, $description, $enabled;
  var $oid;

  function worldnet_sc()
  {
    global $order;

    $this->code        = 'worldnet_sc';
    $this->title       = MODULE_PAYMENT_WORLDNETSC_TEXT_TITLE;
    $this->description = MODULE_PAYMENT_WORLDNETSC_TEXT_DESCRIPTION;
    $this->sort_order  = MODULE_PAYMENT_WORLDNETSC_SORT_ORDER;
    $this->enabled     = ((MODULE_PAYMENT_WORLDNETSC_STATUS == 'True') ? true : false);
    $this->pci         = true;

    if( (int)MODULE_PAYMENT_WORLDNETSC_ORDER_STATUS_ID > 0 )
    {
      $this->order_status = MODULE_PAYMENT_WORLDNETSC_ORDER_STATUS_ID;
    }

    if(is_object($order))
      $this->update_status();

    $this->form_action_url = "https://" . (MODULE_PAYMENT_WORLDNETSC_TEST_MODE == "Yes" ? "test" : "") . (MODULE_PAYMENT_WORLDNETSC_GATEWAY == "WorldNet" ? "payments" : "cashflows") . ".worldnettps.com/merchant/securecardpage";
  }

  // class methods
  function update_status()
  {
    global $order;

    if( ($this->enabled == true) && ((int)MODULE_PAYMENT_WORLDNETSC_ZONE > 0) )
    {
      $check_flag = false;
      $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_WORLDNETSC_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
      while ($check = tep_db_fetch_array($check_query))
      {
        if ($check['zone_id'] < 1)
        {
          $check_flag = true;
          break;
        } 
        elseif ($check['zone_id'] == $order->billing['zone_id'])
        {
          $check_flag = true;
          break;
        }
      }

      if($check_flag == false)
      {
        $this->enabled = false;
      }
    }
  }

  function javascript_validation()
  {
    return false;
  }

  function selection()
  {
    return array( 'id'     => $this->code,
                  'module' => $this->title );
  }

  function pre_confirmation_check()
  {
    return false;
  }

  function confirmation()
  {
    return false;
  }

  function process_button()
  {
    global $osC_Session, $order, $currencies, $currency, $customer_id;

    if ($currency == MODULE_PAYMENT_WORLDNETSC_CURRENCY_2)
    {
        $terminalid  = MODULE_PAYMENT_WORLDNETSC_ID_2;
    	$secret      = MODULE_PAYMENT_WORLDNETSC_SECRET_2;
    }
    else
    {
        $terminalid  = MODULE_PAYMENT_WORLDNETSC_ID;
    	$secret      = MODULE_PAYMENT_WORLDNETSC_SECRET;
    }

    $datetime = date('d-m-Y:H:i:s:000');
    $hash = md5($terminalid . $customer_id . $datetime . 'register' . $secret);

    $process_button_string = tep_draw_hidden_field('TERMINALID',          $terminalid) .
                             tep_draw_hidden_field('ACTION',              'register') .
                             tep_draw_hidden_field('MERCHANTREF',         $customer_id) .
                             tep_draw_hidden_field('DATETIME',            $datetime) .
                             tep_draw_hidden_field('HASH',                $hash);

    return $process_button_string;
  }

  function before_process()
  {
    global $customer_id, $currency;

    $error = false;

    if ($currency == MODULE_PAYMENT_WORLDNETSC_CURRENCY_2)
    {
        $terminalid = MODULE_PAYMENT_WORLDNETSC_ID_2;
    }
    else
    {
        $terminalid = MODULE_PAYMENT_WORLDNETSC_ID;
    }
    $secret = MODULE_PAYMENT_WORLDNETSC_SECRET;

    $merchantRef      = $_REQUEST['MERCHANTREF']     ;
    $cardRef          = $_REQUEST['CARDREFERENCE']   ;
    $datetime         = $_REQUEST['DATETIME']        ;
    $authcode         = $_REQUEST['AUTHCODE']        ;
    $md5hash_post     = $_REQUEST['HASH']            ;
    $responseCode     = $_REQUEST['RESPONSECODE']    ;
    $responseText     = $_REQUEST['RESPONSETEXT']    ;
    $cardType         = $_REQUEST["CARDTYPE"]        ;
    $maskedCardNumber = $_REQUEST["MASKEDCARDNUMBER"];
    $cardCardExpiry   = $_REQUEST["CARDEXPIRY"]      ;

    $md5hash_new = md5($terminalid . $responseCode . $responseText . $merchantRef . $cardRef . $datetime . $secret);

	if($responseCode != "A") {
		if($responseCode == "E02" ) {
			# Card details already stored. Retrieve merchantRef & cardRef from error message text.
			$merchantRef = substr($responseText,69,strlen($responseText));
			$cardRef = substr($responseText,37,16);
			tep_db_query("REPLACE INTO worldnet_securecards VALUES ('$customer_id', '$merchantRef', '$cardRef', '$maskedCardNumber', '$cardCardExpiry', '$cardType');");
		} else {
			$payment_error_return = 'payment_error=' . $this->code . '&error=' . TEXT_WORLDNETSC_RESPONSE_ERROR . '. Bank Response: ' . $RESPONSETEXT;
			tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
		}
	} elseif($md5hash_new == $md5hash_post) {
		switch($responseCode) {
			case "A" :	# SecureCard registration suceeded. You should store the following details against the user account:
					tep_db_query("REPLACE INTO worldnet_securecards VALUES ('$customer_id', '$merchantRef', '$cardRef', '$maskedCardNumber', '$cardCardExpiry', '$cardType');");
					break;
			default  :	# SecureCard registration failed.
					$payment_error_return = 'payment_error=' . $this->code . '&error=' . TEXT_WORLDNETSC_RESPONSE_ERROR . '. Bank Response: ' . $RESPONSETEXT;
					tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
		}
	} else {
		$payment_error_return = 'payment_error=' . $this->code . '&error=' . TEXT_WORLDNETSC_HASH_ERROR . '(' . $md5hash_new . ' vs ' . $md5hash_post . ')';
		tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
	}
    return false;
  }

  function after_process()
  {
    return false;
  }

  function get_error()
  {
    if (PHP_VERSION < 4.1)
    {
      global $_REQUEST;
    }

    $error = array('title' => WORLDNETSC_ERROR_TITLE,
                   'error' => ((isset($_REQUEST['error'])) ? stripslashes(urldecode($_GET['error'])) : TEXT_WORLDNETSC_RESPONSE_ERROR));

    return $error;
  }

  function output_error()
  {
    return false;
  }

  function check()
  {
    if(!isset($this->_check))
    {
      $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_WORLDNETSC_STATUS'");
      $this->_check = tep_db_num_rows($check_query);
    }
    return $this->_check;
  }

  function install()
  {
    tep_db_query(
      "INSERT INTO " . 
      TABLE_CONFIGURATION . 
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
      VALUES 
      (
        'Enable WorldNet TPS Module', 
        'MODULE_PAYMENT_WORLDNETSC_STATUS', 
        'True', 
        'Do you want to accept WorldNet TPS payments?', 
        '6', 
        '1', 
        'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");

    tep_db_query(
      "INSERT INTO " . 
      TABLE_CONFIGURATION . 
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
      VALUES 
      (
        'Gateway', 
        'MODULE_PAYMENT_WORLDNETSC_GATEWAY', 
        'WorldNet', 
        'Under which WorldNet gateway is your account?', 
        '6', 
        '2', 
        'tep_cfg_select_option(array(\'WorldNet\', \'CashFlows\'), ', now())");

    tep_db_query(
      "INSERT INTO " .
      TABLE_CONFIGURATION .
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
      VALUES
      (
        'Test Mode?',
        'MODULE_PAYMENT_WORLDNETSC_TEST_MODE',
        'Yes',
        'Are you in test or live mode?',
        '6',
        '3',
        'tep_cfg_select_option(array(\'Yes\',\'No\'), ', now())");

    tep_db_query(
      "INSERT INTO " .
      TABLE_CONFIGURATION .
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
      VALUES
      (
        'First Transaction Currency',
        'MODULE_PAYMENT_WORLDNETSC_CURRENCY',
        'Selected Currency',
        'The first currency to use for credit card transactions',
        '6',
        '4',
        'tep_cfg_select_option(array(\'EUR\',\'GBP\',\'USD\'), ', now())");

    tep_db_query(
      "INSERT INTO " .
      TABLE_CONFIGURATION .
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
      VALUES
      (
        'First Terminal ID',
        'MODULE_PAYMENT_WORLDNETSC_ID',
        'TerminalID 1',
        'The Terminal ID provided by WorldNet TPS for the first currency',
        '6',
        '5',
        now())");

    tep_db_query(
      "INSERT INTO " . 
      TABLE_CONFIGURATION . 
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
      VALUES 
      (
        'First Shared Secret', 
        'MODULE_PAYMENT_WORLDNETSC_SECRET', 
        'Secret', 
        'The Shared Secret provided by WorldNet TPS for the first currency',
        '6', 
        '7',
        now())");

    tep_db_query(
      "INSERT INTO " .
      TABLE_CONFIGURATION .
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
      VALUES
      (
        'Second Transaction Currency (if applicable)',
        'MODULE_PAYMENT_WORLDNETSC_CURRENCY_2',
        'Selected Currency',
        'The second currency to use for credit card transactions',
        '6',
        '5',
        'tep_cfg_select_option(array(\'EUR\',\'GBP\',\'USD\'), ', now())");

    tep_db_query(
      "INSERT INTO " .
      TABLE_CONFIGURATION .
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
      VALUES
      (
        'Second Terminal ID',
        'MODULE_PAYMENT_WORLDNETSC_ID_2',
        'TerminalID 2',
        'The Terminal ID provided by WorldNet TPS for the second currency',
        '6',
        '6',
        now())");

    tep_db_query(
      "INSERT INTO " . 
      TABLE_CONFIGURATION . 
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
      VALUES 
      (
        'Second Shared Secret', 
        'MODULE_PAYMENT_WORLDNETSC_SECRET_2', 
        'Secret', 
        'The Shared Secret provided by WorldNet TPS for the second currency',
        '6', 
        '7',
        now())");

tep_db_query(
      "INSERT INTO " . 
      TABLE_CONFIGURATION . 
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
      VALUES 
      (
        'Sort order of display.', 
        'MODULE_PAYMENT_WORLDNETSC_SORT_ORDER', 
        '0', 
        'Sort order of display. Lowest is displayed first.', 
        '6', 
        '9',
        now())");
  
    tep_db_query(
      "INSERT INTO " .
      TABLE_CONFIGURATION .
      " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added)
      VALUES
      (
        'Set Order Status',
        'MODULE_PAYMENT_WORLDNETSC_ORDER_STATUS_ID',
        '0',
        'Set the status of orders made with this payment module to this value',
        '6',
        '10',
        'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");

    tep_db_query(
      "CREATE TABLE `worldnet_securecards` (
      `customers_id` int(11) NOT NULL,
      `merchant_ref` int(11) NOT NULL,
      `card_ref` varchar(16) NOT NULL,
      `obscured_pan` varchar(20) NOT NULL,
      `expiry` varchar(4) NOT NULL,
      `card_type` varchar(30) NOT NULL,
      PRIMARY KEY (`customers_id`)
    ) ENGINE=MyISAM DEFAULT CHARSET=latin1");
  }

  function remove()
  {
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key like 'MODULE_PAYMENT_WORLDNETSC%';");
  }

  function keys()
  {
    return array(
      'MODULE_PAYMENT_WORLDNETSC_STATUS'              ,
      'MODULE_PAYMENT_WORLDNETSC_GATEWAY'             ,
      'MODULE_PAYMENT_WORLDNETSC_TEST_MODE'           ,
      'MODULE_PAYMENT_WORLDNETSC_CURRENCY'            ,
      'MODULE_PAYMENT_WORLDNETSC_ID'                  ,
      'MODULE_PAYMENT_WORLDNETSC_SECRET'              ,
      'MODULE_PAYMENT_WORLDNETSC_CURRENCY_2'          ,
      'MODULE_PAYMENT_WORLDNETSC_ID_2'                ,
      'MODULE_PAYMENT_WORLDNETSC_SECRET_2'            ,
      'MODULE_PAYMENT_WORLDNETSC_ORDER_STATUS_ID'     ,
      'MODULE_PAYMENT_WORLDNETSC_SORT_ORDER');
  }
}

?>
